/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
	"fmt"
)

// FlowOperationFormat - struct for FlowOperationFormat
type FlowOperationFormat struct {
	FlowOperationFormat *FlowOperationFormat
}

// FlowOperationFormatAsFlowOperationFormat is a convenience function that returns FlowOperationFormat wrapped in FlowOperationFormat
func FlowOperationFormatAsFlowOperationFormat(v *FlowOperationFormat) FlowOperationFormat {
	return FlowOperationFormat{
		FlowOperationFormat: v,
	}
}

// Unmarshal JSON data into one of the pointers in the struct
func (dst *FlowOperationFormat) UnmarshalJSON(data []byte) error {
	var err error
	// this object is nullable so check if the payload is null or empty string
	if string(data) == "" || string(data) == "{}" {
		return nil
	}

	match := 0
	// try to unmarshal data into FlowOperationFormat
	err = newStrictDecoder(data).Decode(&dst.FlowOperationFormat)
	if err == nil {
		jsonFlowOperationFormat, _ := json.Marshal(dst.FlowOperationFormat)
		if string(jsonFlowOperationFormat) == "{}" { // empty struct
			dst.FlowOperationFormat = nil
		} else {
			match++
		}
	} else {
		dst.FlowOperationFormat = nil
	}

	if match > 1 { // more than 1 match
		// reset to nil
		dst.FlowOperationFormat = nil

		return fmt.Errorf("data matches more than one schema in oneOf(FlowOperationFormat)")
	} else if match == 1 {
		return nil // exactly one match
	} else { // no match
		return fmt.Errorf("data failed to match schemas in oneOf(FlowOperationFormat)")
	}
}

// Marshal data from the first non-nil pointers in the struct to JSON
func (src FlowOperationFormat) MarshalJSON() ([]byte, error) {
	if src.FlowOperationFormat != nil {
		return json.Marshal(&src.FlowOperationFormat)
	}

	return nil, nil // no data in oneOf schemas
}

// Get the actual instance
func (obj *FlowOperationFormat) GetActualInstance() interface{} {
	if obj == nil {
		return nil
	}
	if obj.FlowOperationFormat != nil {
		return obj.FlowOperationFormat
	}

	// all schemas are nil
	return nil
}

type NullableFlowOperationFormat struct {
	value *FlowOperationFormat
	isSet bool
}

func (v NullableFlowOperationFormat) Get() *FlowOperationFormat {
	return v.value
}

func (v *NullableFlowOperationFormat) Set(val *FlowOperationFormat) {
	v.value = val
	v.isSet = true
}

func (v NullableFlowOperationFormat) IsSet() bool {
	return v.isSet
}

func (v *NullableFlowOperationFormat) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableFlowOperationFormat(val *FlowOperationFormat) *NullableFlowOperationFormat {
	return &NullableFlowOperationFormat{value: val, isSet: true}
}

func (v NullableFlowOperationFormat) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableFlowOperationFormat) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
